
local AlarmHUDmage_LastUpdate = 0

local AlarmHUDmage_HasImprovedScorch = 0
local AlarmHUDmage_DurationImprovedScorch = 0
local AlarmHUDmage_NeedsImprovedScorch = false

local AlarmHUDmage_HasLivingBomb = false
local AlarmHUDmage_DurationLivingBomb = 0
local AlarmHUDmage_NeedsLivingBomb = false

local AlarmHUDmage_HasHot = false
local AlarmHUDmage_DurHot = 0

local AlarmHUDmage_HasAB = 0
local AlarmHUDmage_DurAB = 0

local AlarmHUDmage_HasMB = false
local AlarmHUDmage_DurMB = 0

local AlarmHUDmage_HasFB = false
local AlarmHUDmage_DurFB = 0

local AlarmHUDmage_ImprovedScorch = GetSpellInfo(12873)
local AlarmHUDmage_WintersChill = GetSpellInfo(12579)
local AlarmHUDmage_ShadowMastery = GetSpellInfo(17800)
local AlarmHUDmage_HotStreak = GetSpellInfo(48108)
local AlarmHUDmage_LivingBomb = GetSpellInfo(55360)
local AlarmHUDmage_ArcaneBlast = GetSpellInfo(42897)
local AlarmHUDmage_MissileBarrage = GetSpellInfo(54490)
local AlarmHUDmage_Fireball = GetSpellInfo(57761)

local _, _, _, _, tSc, _, _, _ = GetTalentInfo(2, 11)
local _, _, _, _, tLb, _, _, _ = GetTalentInfo(2, 28)
local _, _, _, _, tMb, _, _, _ = GetTalentInfo(1, 27)
local _, _, _, _, tBf, _, _, _ = GetTalentInfo(3, 24)


local function AlarmHUDmage_UpdateTalents()
  _, _, _, _, tSc, _, _, _ = GetTalentInfo(2, 11)
  _, _, _, _, tLb, _, _, _ = GetTalentInfo(2, 28)
  _, _, _, _, tMb, _, _, _ = GetTalentInfo(1, 27)
  _, _, _, _, tBf, _, _, _ = GetTalentInfo(3, 24)

  print("AlarmHUDmage detected talent changes.")

  if tSc > 0 then
    print(format("  %s  ACTIVE", AlarmHUDmage_ImprovedScorch))
  end

  if tLb > 0 then
    print(format("  %s  ACTIVE", AlarmHUDmage_LivingBomb))
  end

  if tMb > 0 then
    print(format("  %s  ACTIVE", AlarmHUDmage_MissileBarrage))
  end
  
  if tBf > 0 then
    print(format("  %s  ACTIVE", AlarmHUDmage_Fireball))
  end
end


local t = UIParent:CreateFontString()
t:SetFontObject("GameFontNormal")
t:SetPoint("CENTER")

local t2 = UIParent:CreateFontString()
t2:SetFontObject("GameFontNormal")
t2:SetPoint("BOTTOM", t, "TOP")
t2:SetTextColor(1, 0.7, 0.7)

local t3 = UIParent:CreateFontString()
t3:SetFontObject("GameFontNormal")
t3:SetPoint("TOP", t, "BOTTOM")
t3:SetTextColor(0.7, 0.7, 1)

local function AlarmHUDmageFrame_CheckCasting()
  local s = UnitCastingInfo("target")
  
  if s then
    t2:SetFormattedText("CASTING --- %s", s)
  else
    s = UnitChannelInfo("target")

    if s then
      t2:SetFormattedText("CHANNELING --- %s", s)
    else
      t2:SetText("")
    end
  end
end

local function AlarmHUDmageFrame_CheckBuffs()
  AlarmHUDmage_HasHot = false
  AlarmHUDmage_DurHot = 0
  AlarmHUDmage_HasAB = 0
  AlarmHUDmage_DurAB = 0
  AlarmHUDmage_HasMB = false
  AlarmHUDmage_DurMB = 0
  AlarmHUDmage_HasFB = false
  AlarmHUDmage_DurFB = 0

  local _, _, _, c, _, _, t, _, _ = UnitBuff("player", AlarmHUDmage_HotStreak)
  
  if t then
    AlarmHUDmage_HasHot = true
    AlarmHUDmage_DurHot = t - GetTime()
  end

  _, _, _, c, _, _, t, _, _ = UnitDebuff("player", AlarmHUDmage_ArcaneBlast)
    
  if t then
    AlarmHUDmage_HasAB = c
    AlarmHUDmage_DurAB = t - GetTime()
  end

  if tMb then
    _, _, _, c, _, _, t, _, _ = UnitBuff("player", AlarmHUDmage_MissileBarrage)

    if t then
      AlarmHUDmage_HasMB = true
      AlarmHUDmage_DurMB = t - GetTime()
    end
  end

  if tBf then
    _, _, _, c, _, _, t, _, _ = UnitBuff("player", AlarmHUDmage_Fireball)

    if t then
      AlarmHUDmage_HasFB = true
      AlarmHUDmage_DurFB = t - GetTime()
    end
  end  
end

local function AlarmHUDmageFrame_CheckDebuffs()
  AlarmHUDmage_HasImprovedScorch = 0
  AlarmHUDmage_DurationImprovedScorch = 0
  AlarmHUDmage_NeedsImprovedScorch = true

  AlarmHUDmage_HasLivingBomb = false
  AlarmHUDmage_DurationLivingBomb = 0
  AlarmHUDmage_NeedsLivingBomb = true
  
  if (not UnitCanAttack("player", "target")) then
    AlarmHUDmage_NeedsImprovedScorch = false
    AlarmHUDmage_NeedsLivingBomb = false
    t3:SetText("")
    return
  end
  
  if tSc < 1 then
    AlarmHUDmage_NeedsImprovedScorch = false
  end
  
  if tLb < 1 then
    AlarmHUDmage_NeedsLivingBomb = false
  end

  local i = 1
  local buffs = "SPELLSTEAL"
  local n, _, _, c, _, _, t, m, s = UnitBuff("target", i)

  while n do
    if s then
      buffs = strjoin(" --- ", buffs, n)
    end

    i = i + 1
    n, _, _, c, _, _, t, m, s = UnitBuff("target", i)
  end

  if buffs == "SPELLSTEAL" then
    t3:SetText("")
  else
    t3:SetText(buffs)
  end

  i = 1
  n, _, _, c, _, _, t, m, s = UnitDebuff("target", i)

  while n do
    if n == AlarmHUDmage_WintersChill or n == AlarmHUDmage_ShadowMastery then
      AlarmHUDmage_NeedsImprovedScorch = false
    elseif n == AlarmHUDmage_ImprovedScorch then
      AlarmHUDmage_HasImprovedScorch = c
      AlarmHUDmage_DurationImprovedScorch = t - GetTime()

      if AlarmHUDmage_DurationImprovedScorch > 9 and c > 4 then
        AlarmHUDmage_NeedsImprovedScorch = false
      end
    elseif m == "player" and n == AlarmHUDmage_LivingBomb then
      AlarmHUDmage_HasLivingBomb = true
      AlarmHUDmage_DurationLivingBomb = t - GetTime()
      
      if AlarmHUDmage_DurationLivingBomb > 2 then
        AlarmHUDmage_NeedsLivingBomb = false
      end
    end

    i = i + 1
    n, _, _, c, _, _, t, m, s = UnitDebuff("target", i)
  end
end

local function AlarmHUDmageFrame_UpdateText()
  if AlarmHUDmage_HasFB then
    t:SetFormattedText(">>> %s - %d <<<", AlarmHUDmage_Fireball, AlarmHUDmage_DurFB)
    t:SetTextColor(0.75, 0.66, 1)
  elseif AlarmHUDmage_HasMB and AlarmHUDmage_HasAB < 3 then
    t:SetFormattedText("> %d - %s - %d <", AlarmHUDmage_HasAB, AlarmHUDmage_MissileBarrage, AlarmHUDmage_DurMB)
    t:SetTextColor(1, 0.5, 0)
  elseif AlarmHUDmage_HasMB then
    t:SetFormattedText(">>> %s - %d <<<", AlarmHUDmage_MissileBarrage, AlarmHUDmage_DurMB)
    t:SetTextColor(1, 0.75, 0)
  elseif AlarmHUDmage_HasAB > 0 and AlarmHUDmage_HasAB < 3 then
    t:SetFormattedText("> %d - %s - %d <", AlarmHUDmage_HasAB, AlarmHUDmage_ArcaneBlast, AlarmHUDmage_DurAB)
    t:SetTextColor(0, 0.5, 1)
  elseif AlarmHUDmage_HasAB == 3 then
    t:SetFormattedText(">>> %s - %d <<<", AlarmHUDmage_ArcaneBlast, AlarmHUDmage_DurAB)
    t:SetTextColor(0.5, 1, 0.5)
  elseif AlarmHUDmage_NeedsImprovedScorch and AlarmHUDmage_HasImprovedScorch > 0 then
    t:SetFormattedText("> %d - %s - %d <", AlarmHUDmage_HasImprovedScorch, AlarmHUDmage_ImprovedScorch, AlarmHUDmage_DurationImprovedScorch)
    t:SetTextColor(1, 1, 0)
  elseif AlarmHUDmage_HasHot then
    t:SetFormattedText(">>> %s - %d <<<", AlarmHUDmage_HotStreak, AlarmHUDmage_DurHot)
    t:SetTextColor(1, 0.3, 0.3)
  elseif AlarmHUDmage_NeedsLivingBomb and (not AlarmHUDmage_HasLivingBomb) then
    t:SetFormattedText(">>> %s <<<", AlarmHUDmage_LivingBomb)
    t:SetTextColor(1, 0.7, 0.3)
  elseif AlarmHUDmage_NeedsImprovedScorch then
    t:SetFormattedText(">>> %s <<<", AlarmHUDmage_ImprovedScorch)
    t:SetTextColor(1, 1, 0.3)
  elseif AlarmHUDmage_NeedsLivingBomb and AlarmHUDmage_HasLivingBomb then
    t:SetFormattedText("> %s - %d <", AlarmHUDmage_LivingBomb, AlarmHUDmage_DurationLivingBomb)
    t:SetTextColor(1, 0.7, 0.3)
  else
    t:SetText("")
  end
end

local f = CreateFrame("Frame")

if select(2, UnitClass("player")) == "MAGE" then
  f:SetScript("OnUpdate",
    function()
      if (GetTime() - AlarmHUDmage_LastUpdate) > 0.2 then
        AlarmHUDmage_LastUpdate = GetTime()
        AlarmHUDmageFrame_CheckCasting()
        AlarmHUDmageFrame_CheckBuffs()
        AlarmHUDmageFrame_CheckDebuffs()
        AlarmHUDmageFrame_UpdateText()
      end
    end
  )

  f:RegisterEvent("PLAYER_TALENT_UPDATE")

  f:SetScript("OnEvent",
    function()
      AlarmHUDmage_UpdateTalents()
    end
  )
else
  f:SetScript("OnUpdate",
    function()
      if (GetTime() - AlarmHUDmage_LastUpdate) > 0.2 then
        AlarmHUDmage_LastUpdate = GetTime()
        AlarmHUDmageFrame_CheckCasting()
      end
    end
  )
end
